# Contributing to Switcher Project

The following is a set of guidelines for contributing to Switcher Project. These are mostly guidelines, not rules. Use your best judgment, and feel free to propose changes to this document in a pull request.

#### Table Of Contents

[Code of Conduct](#code-of-conduct)

[How Can I Contribute?](#how-can-i-contribute)
  * [Reporting Bugs](#reporting-bugs)
  * [Suggesting Enhancements](#suggesting-enhancements)
  * [Your First Code Contribution](#your-first-code-contribution)
  * [Pull Requests](#pull-requests)

## Code of Conduct

This project and everyone participating in it is governed by the [Switcher Project Code of Conduct](CODE_OF_CONDUCT.md). By participating, you are expected to uphold this code. Please report unacceptable behavior to [switcher.project@gmail.com](mailto:switcher.project@gmail.com).

You can join the Switcher-HQ Slack team:

* [Join the Slack Team](https://switcher-hq.slack.com/)
    * Even though Slack is a chat service, sometimes it takes several hours for community members to respond &mdash; please be patient!
    * Use the `#random` channel for general questions or discussion about Switcher Project

## How Can I Contribute?

### Reporting Bugs

This section guides you through submitting a bug report. Following these guidelines helps maintainers and the community understand your report, reproduce the behavior, and find related reports.

1. Use the GitHub issue search — check if the issue has already been reported.
2. Check if the issue has been fixed — try to reproduce it using the latest master or development branch in the repository.

Example:

> Short and descriptive example bug report title
>
> A summary of the issue. If suitable, include the steps required to reproduce the bug.
>
> 1. This is the first step
> 2. This is the second step
> 3. Further steps, etc.
>
> Any other information you want to share that is relevant to the issue being
> reported. This might include the lines of code that you have identified as
> causing the bug, and potential solutions (and your opinions on their
> merits).

> **Note:** If you find a **Closed** issue that seems like it is the same thing that you're experiencing, open a new issue and include a link to the original issue in the body of your new one.

### Suggesting Enhancements

This section guides you through submitting an enhancement suggestion for Switcher Project, including completely new features and minor improvements to existing functionality. Following these guidelines helps maintainers and the community understand your suggestion and find related suggestions.

Simply create an issue and provide the following information:

* **Use a clear and descriptive title** for the issue to identify the suggestion.
* **Provide a step-by-step description of the suggested enhancement** in as much detail as possible. This additional context helps the maintainers to understand the enhancement from your perspective
* **Explain why this enhancement would be useful**

### Your First Code Contribution

Unsure where to begin contributing to Switcher? You can start by looking through these `minor-issue` and `bug` issues:

* Minor issue - issues which should only require a few lines of code, and a test or two.
* Bug - issues which should be a bit more involved than `minor` issues.

### Pull Requests

The process described here has several goals:

- Maintain Switcher's Project quality
- Fix problems that are important to users
- Engage the community in working toward the best possible Switcher
- Enable a sustainable system for Switcher's maintainers to review contributions

Please follow these steps to have your contribution considered by the maintainers:

1. Fork the repository
2. Clone the repository
3. Create a branch
4. Make necessary changes and commit those changes
5. Push changes to GitHub
6. Submit your changes for review
7. Keeping your fork synced with this repository